//
//  RefreshView.swift
//  SwiftRefresh
//
//  Created by 吾久 on 2017/7/24.
//  Copyright © 2017年 吾久. All rights reserved.
//

import UIKit



class RefreshView: UIView,UIScrollViewDelegate,CAAnimationDelegate {

    fileprivate var width:CGFloat!
    fileprivate var height:CGFloat!
    fileprivate var gradientlayer:CAGradientLayer!
    fileprivate var centerview:UIView!
    fileprivate var eyeview:UIView!

    var scrollview:UIScrollView!
    var progress:CGFloat = 0.0
    var isRefreshing = false


    init(frame:CGRect,scrollView:UIScrollView,didRefreshBlock:()->Void) {
        super.init(frame: frame)
        width = frame.width
        height = frame.height
        scrollview = scrollView
        drawEyes()
        self.layer.addSublayer(shapeLayer())
        openxielunyan()

    }


    //眼框
    func shapeLayer()-> CAShapeLayer {

        let shaplayer = CAShapeLayer()
        let bezier = UIBezierPath()
        bezier.move(to: CGPoint(x: 10, y: height / 2.0 + 30))
        bezier.addArc(withCenter: CGPoint(x: width / 2.0, y: height / 2.0 + 30), radius: width / 2.0 - 10, startAngle: CGFloat.pi, endAngle: CGFloat.pi / 6 * 7, clockwise: true)
        bezier.addArc(withCenter: CGPoint(x: width / 2.0, y: height / 2.0 + 30 - 30 - sin(CGFloat(CGFloat.pi / 6)) * (width / 2.0 - 30)), radius: sin(0.15) * 1100.0, startAngle: 0.08, endAngle: CGFloat.pi / 7 * 3.5, clockwise: true)
        bezier.addQuadCurve(to: CGPoint(x: 10, y: height / 2 + 30), controlPoint: CGPoint(x: width * 0.35, y: height / 2 + 90))
        shaplayer.path = bezier.cgPath
        shaplayer.lineWidth = 3
        shaplayer.fillColor = UIColor.clear.cgColor
        shaplayer.strokeColor = UIColor.black.cgColor
        return shaplayer
    }

    //眼球
    func drawEyes() {

        let eyesgradinelayer = CAGradientLayer()
        eyesgradinelayer.frame = CGRect(x: (width - width / 5.0 * 2)/2.0, y: (height - width / 5.0 * 2)/2.0, width: width / 5.0 * 2, height: width / 5.0 * 2.0)
        eyesgradinelayer.colors = [UIColor.black.cgColor,UIColor.gray.cgColor]
        eyesgradinelayer.startPoint = CGPoint(x: 0, y: 0)
        eyesgradinelayer.endPoint = CGPoint(x: 0, y: 1)
        eyesgradinelayer.locations = [0,1.2]
        eyesgradinelayer.cornerRadius = width / 5.0


        let eyeslayer = CAShapeLayer()
        let bezier = UIBezierPath()
        bezier.move(to: CGPoint(x: width / 2.0 + width / 5.0, y: height / 2.0))
        bezier.addArc(withCenter: CGPoint(x: width / 2.0, y: height / 2.0), radius: width / 5.0, startAngle: 0, endAngle: CGFloat.pi * 2, clockwise: true)
        eyeslayer.fillColor = UIColor.clear.cgColor
        eyeslayer.lineWidth = 3.0
        eyeslayer.path = bezier.cgPath
        eyeslayer.strokeColor = UIColor.black.cgColor
        eyeslayer.addSublayer(eyesgradinelayer)
        self.layer.addSublayer(eyeslayer)

        let shapelayer = shapeLayer()
        shapelayer.fillColor = UIColor.blue.cgColor
        eyeslayer.mask = shapelayer

        //眼球颜色
        drawColor()
        centerview = UIView()
        centerview.bounds = CGRect(x: 0, y: 0, width: 35, height: 35)
        centerview.layer.cornerRadius = 35/2.0
        centerview.center = CGPoint(x: width / 2.0, y: height / 2.0)
        centerview.backgroundColor = UIColor.black
        self.layer.addSublayer(centerview.layer)

    }

    //颜色
    func drawColor(){

        gradientlayer = CAGradientLayer()
        eyeview = UIView()
        gradientlayer.frame = CGRect(x: (width - width / 5.0 * 2)/2.0, y: (height - width / 5.0 * 2)/2.0, width: width / 5.0 * 2, height: width / 5.0 * 2.0)
        gradientlayer.colors = [UIColor.red.cgColor,UIColor.gray.cgColor]
        gradientlayer.startPoint = CGPoint(x: 0, y: 0)
        gradientlayer.endPoint = CGPoint(x: 0, y: 1)
        gradientlayer.locations = [0,1.2]
        gradientlayer.cornerRadius = width / 5.0
        gradientlayer.opacity = 0
        eyeview.layer.addSublayer(gradientlayer)
        self.layer.addSublayer(eyeview.layer)
        let shapelayer = shapeLayer()
        shapelayer.fillColor = UIColor.black.cgColor
        eyeview.layer.mask = shapelayer

    }


    func openxielunyan(){

        let xielunyanview = UIView()
        xielunyanview.frame = CGRect(x: 0, y: 0, width: width / 2.0 - 40, height: width / 2.0 - 40)
        xielunyanview.center = CGPoint(x: width/2.0, y: height/2.0)

        for i in 0..<3 {

            let pointPoint = CGPoint(x: width / 4 - 20 + cos(CGFloat.pi * (2.0 / 3 * CGFloat(i) + 1.0 / 6)) * (width / 4 - 30), y: width / 4 - 20 + sin(CGFloat.pi * (2.0 / 3 * CGFloat(i) + 1.0 / 6)) * (width / 4 - 30))

            let controlPoint = CGPoint(x:width / 4 - 20 + cos(CGFloat.pi * (2.0 / 3 * CGFloat(i) + 1.0 / 12)) * (width / 4 - 20),y:width / 4 - 20 + sin(CGFloat.pi * (2.0 / 3 * CGFloat(i) + 1.0 / 12)) * (width / 4 - 20))

            let shapelayer1 = CAShapeLayer()
            shapelayer1.cornerRadius = 20
            let bezier = UIBezierPath()
            var y = (width / 4 - 30) * sin(CGFloat.pi * 2.0 / 3 * CGFloat(i))
            y = y + width / 4 - 20.0
            var x = (width / 4 - 30) * cos(CGFloat.pi * 2.0 / 3 * CGFloat(i))
            x = x + width / 4 - 20.0

            let point = CGPoint(x: x, y: y)
            let startPoint = CGPoint(x: point.x + cos(CGFloat.pi * 2 / 3 * CGFloat(i + 1) + CGFloat.pi / 6) * 10, y: point.y + sin(CGFloat.pi * 2 / 3 * CGFloat(i + 1) + CGFloat.pi / 6) * 10)
            bezier.move(to: pointPoint)
            bezier.addQuadCurve(to: startPoint, controlPoint: controlPoint)
            bezier.addArc(withCenter: point, radius: 10, startAngle: (CGFloat.pi * 2 / 3 * CGFloat(i + 1) + CGFloat.pi / 6), endAngle:CGFloat.pi * 2 / 3 * CGFloat(i + 1) + CGFloat.pi / 6 + 2 * CGFloat.pi - CGFloat.pi / 1.4, clockwise: true)
            bezier.addQuadCurve(to: pointPoint, controlPoint: controlPoint)

            shapelayer1.path = bezier.cgPath
            shapelayer1.lineWidth = 1
            shapelayer1.fillColor = UIColor.black.cgColor
            shapelayer1.strokeColor = UIColor.black.cgColor
            gradientlayer.addSublayer(shapelayer1)
        }

        for i in 0..<34 {

            let shapelayer2 = CAShapeLayer()
            let bezier = UIBezierPath(arcCenter: CGPoint(x: width / 4 - 20, y: width / 4 - 20), radius: width / 4 - 35, startAngle: CGFloat(i) / 34 * CGFloat.pi * 2, endAngle: CGFloat(i) / 34 * CGFloat.pi * 2 + CGFloat.pi / 360, clockwise: true)
            shapelayer2.path = bezier.cgPath
            shapelayer2.lineWidth = CGFloat((arc4random() % 10) + 5)
            shapelayer2.strokeColor = UIColor.black.cgColor
            shapelayer2.fillColor = UIColor.clear.cgColor
            gradientlayer.addSublayer(shapelayer2)
        }
    }



    func scrollViewDidScroll(_ scrollView: UIScrollView) {

        let offsetY = max(-(scrollView.contentOffset.y + scrollView.contentInset.top), 0.0)
        progress = min(max(offsetY / self.frame.size.height, 0.0), 1.0)

        if !isRefreshing {

            gradientlayer.opacity = Float(progress)

        }

    }

    func scrollViewWillEndDragging(_ scrollView: UIScrollView, withVelocity velocity: CGPoint, targetContentOffset: UnsafeMutablePointer<CGPoint>) {

        if !isRefreshing && self.progress >= 1.0 {

            beginRefresh()

            UIView.transition(with: self, duration: 1, options: .curveLinear, animations: {


            }, completion: { (bool) in

                self.changeEyes()


                let rotatTranform = CABasicAnimation(keyPath: "transform.rotation.z")
                rotatTranform.delegate = self
                rotatTranform.duration = 1
                rotatTranform.toValue = NSNumber(value: -Float.pi * 2)
                rotatTranform.isRemovedOnCompletion = false
                rotatTranform.repeatCount = 10
                self.gradientlayer.add(rotatTranform, forKey: "rotationAnimation")
            })
        }
    }

    func changeEyes(){

        for parlayer:CALayer in gradientlayer.sublayers! as [CALayer] {

            if parlayer is CAShapeLayer {

                if parlayer.cornerRadius == 20 {

                    parlayer.opacity = 0
                }
            }
        }


        let shapelayer = CAShapeLayer()
        let bezier = UIBezierPath()
        bezier.move(to: CGPoint(x: width / 4 - 20 + cos(CGFloat.pi * 2.0 / 3 * CGFloat(2)) * (width / 4 - 30), y: width / 4 - 20 + sin(CGFloat.pi * 2.0 / 3 * CGFloat(2)) * (width / 4 - 30)))

        for i in 0..<3 {

            let pointTop = CGPoint(x: width / 4 - 20 + cos(CGFloat.pi * 2.0 / 3 * CGFloat(i)) * (width / 4 - 30), y: width / 4 - 20 + sin(CGFloat.pi * 2.0 / 3 * CGFloat(i)) * (width / 4 - 30))
            let leftPoint = CGPoint(x: width / 4 - 20 + cos(CGFloat.pi * (CGFloat(i) * 2.0 / 3 - 1.0 / 3.0)) * 12, y: width / 4 - 20 + sin(CGFloat.pi * (CGFloat(i) * 2.0 / 3 - 1.0 / 3.0)) * 12)
            bezier.addLine(to: leftPoint)
            bezier.addLine(to: pointTop)
        }


        for i in 0..<4 {

            let c:CGFloat = 48
            let pointTop = CGPoint(x: width / 4 - 20 + cos(CGFloat.pi * 2.0 / 3 * CGFloat(i)) * (width / 4 - 30), y: width / 4 - 20 + sin(CGFloat.pi * 2.0 / 3 * CGFloat(i)) * (width / 4 - 30))
            let nextTop = CGPoint(x: width / 4 - 20 + cos(CGFloat.pi * 2.0 / 3 * CGFloat(i + 1)) * (width / 4 - 30), y: width / 4 - 20 + sin(CGFloat.pi * 2.0 / 3 * CGFloat(i + 1)) * (width / 4 - 30))
            let controlPoint = CGPoint(x: width / 4 - 20 + cos(CGFloat.pi * 2.0 / 3 * CGFloat(CGFloat(i) + 0.5)) * (width / 4 - c), y: width / 4 - 20 + sin(CGFloat.pi * 2.0 / 3 * CGFloat(CGFloat(i) + 0.5)) * (width / 4 - c))
            let selfCenter = CGPoint(x: (pointTop.x + width / 4 - 20) / 2 , y: (pointTop.y + width / 4 - 20) / 2)
            let otherCenter = CGPoint(x: (nextTop.x + width / 4 - 20) / 2, y: (nextTop.y + width / 4 - 20) / 2)
            bezier.move(to: pointTop)
            bezier.addQuadCurve(to: otherCenter, controlPoint: controlPoint)
            bezier.addQuadCurve(to: selfCenter, controlPoint: controlPoint)
        }

        bezier.move(to: CGPoint(x: width / 4 - 20 + 10, y: width / 4 - 20))
        bezier.addArc(withCenter: CGPoint(x: width / 4 - 20, y: width / 4 - 20), radius: 10, startAngle: 0, endAngle: CGFloat.pi * 2, clockwise: true)
        shapelayer.path = bezier.cgPath
        shapelayer.strokeColor = UIColor.black.cgColor
        shapelayer.fillColor = UIColor.black.cgColor
        shapelayer.name = "万花镜"
        gradientlayer.addSublayer(shapelayer)

    }


    func animationDidStop(_ anim: CAAnimation, finished flag: Bool) {

        endRefresh()
        for parlayer:CALayer in gradientlayer.sublayers! as [CALayer] {
            if parlayer is CAShapeLayer {
                if parlayer.name == "万花镜" {
                    parlayer.removeFromSuperlayer()
                }

                if parlayer.cornerRadius == 20 {

                    parlayer.opacity = 1
                }

            }
        }
    }


    func beginRefresh(){

        isRefreshing = true
        var insets = scrollview.contentInset
        insets.top += self.frame.size.height
        scrollview.contentInset = insets
    }


    func endRefresh() {

        isRefreshing = false

        UIView.animate(withDuration: 0.3, delay: 0.0, options: .curveEaseOut, animations: { 

            var insets = self.scrollview.contentInset
            insets.top -= self.frame.size.height
            self.scrollview.contentInset = insets
            
        }) { (bool) in


        }
    }

    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }

    /*
    // Only override draw() if you perform custom drawing.
    // An empty implementation adversely affects performance during animation.
    override func draw(_ rect: CGRect) {
        // Drawing code
    }
    */

}
